ICode9

精准搜索请尝试: 精确搜索
首页 > 数据库> 文章详细

postgresql plv8 安装

2019-11-07 18:00:09  阅读:37  来源: 互联网

标签:postgresql && com apt build https plv8 安装



网上可以看到pg 9.6 版本的plv8容器镜像,但是在基于原有dockerfile 进行构建的时候,居然失败了,有墙的问题,有版本的问题
所以通过虚拟机尝试下构建方式安装以及对于碰到问题的解决

说明centos 系统不太好使,安装起来有点费事,使用的Debian

安装pg

pg11

  • pg repo
 
touch /etc/apt/sources.list.d/pgdg.list
deb http://apt.postgresql.org/pub/repos/apt/ stretch-pgdg main
wget --quiet -O - https://www.postgresql.org/media/keys/ACCC4CF8.asc | sudo apt-key add -
sudo apt-get update
  • 安装
apt-get install postgresql-11 postgresql-server-dev-11 
 
  • 配置pg_Config
    可选,默认会自动配置,对于多环境的可能需要,可以结合find locate 工具查找

构建

  • 预备
 
apt install  git pkg-config libc++-dev libc++abi-dev
  • clone 代码
wget https://github.com/plv8/plv8/archive/v2.3.9.tar.gz
  • 构建
tar -xvzf v2.3.9.tar.gz
cd plv8-2.3.9
make
make install

使用

  • 启动扩展
CREATE EXTENSION plv8;
  • 简单函数
CREATE OR REPLACE FUNCTION plv8_eval_test()
RETURNS text AS $$
  var result = eval("1+2")
  return JSON.stringify(result);
$$ LANGUAGE plv8 IMMUTABLE STRICT;
  • 调用
select * from plv8_eval_test();
  • 效果

 

 

docker 镜像

 
 # Docker image for PostgreSQL with the plv8 extensions installed
# Note: building plv8 from source takes a long time, and will timeout with Docker Hub's
# automated builds. See the main Dockerfile for an image that uses pre-built binaries
# (built using this Dockerfile.build)
# Provided by Ionx Solutions: https://www.ionxsolutions.com
# Begin by building plv8
FROM postgres:11.1 AS build
ENV PLV8_VERSION 2.3.8
ENV PLV8_SHASUM="b3ffb95daeb21b17bc5670f372403879dfad7eee86e0152e4da763ffd16fbf07 ${PLV8_VERSION}.tar.gz"
RUN buildDeps="curl build-essential ca-certificates git python gnupg libc++-dev libc++abi-dev pkg-config glib2.0" \
    && apt-get update \
    && apt-get install -y --no-install-recommends ${buildDeps} \
    && echo "deb http://apt.postgresql.org/pub/repos/apt/ stretch-pgdg main" > /etc/apt/sources.list.d/pgdg.list \
    && curl https://www.postgresql.org/media/keys/ACCC4CF8.asc | apt-key add - \
    && apt-get update \
    && apt-get install -y --no-install-recommends postgresql-server-dev-$PG_MAJOR \
    && git config --global user.email "nobody@example.com" \
    && git config --global user.name "nobody" \
    && mkdir -p /tmp/build \
    && curl -o /tmp/build/${PLV8_VERSION}.tar.gz -SL "https://github.com/plv8/plv8/archive/v${PLV8_VERSION}.tar.gz" \
    && cd /tmp/build \
    && echo ${PLV8_SHASUM} | sha256sum -c \
    && tar -xzf /tmp/build/${PLV8_VERSION}.tar.gz -C /tmp/build/ \
    && cd /tmp/build/plv8-${PLV8_VERSION} \
    && sed -i '104i%.bc : %.cc\n\t$(COMPILE.cxx.bc) $(CCFLAGS) $(CPPFLAGS) -fPIC -c -o $@ $<\n' Makefile.shared \
    && make static \
    && make install \
    && strip /usr/lib/postgresql/${PG_MAJOR}/lib/plv8-${PLV8_VERSION}.so \
    && cd / \
    && rm -rf /tmp/build \
    && apt-get remove -y --purge ${buildDeps} \
    && apt-get autoremove -y --purge \
    && rm -rf /var/lib/apt/lists/

几个问题

  • v8 代码包的问题
    主要是墙的问题,合理上网解决
  • make: * No rule to make target 'plv8.bc', needed by 'all
    参考 https://github.com/plv8/plv8/issues/304 使用高版本,比如我使用2.3.9 ,在测试2.3.8 版本的时候碰到的此问题

参考资料

https://github.com/plv8/plv8
https://github.com/clkao/plv8x
https://github.com/plv8/plv8/issues/304
https://github.com/clkao/docker-postgres-plv8



标签:postgresql,&&,com,apt,build,https,plv8,安装
来源: https://www.cnblogs.com/rongfengliang/p/11813889.html

专注分享技术,共同学习,共同进步。侵权联系[admin#icode9.com]

Copyright (C)ICode9.com, All Rights Reserved.

ICode9版权所有